/**
 * 
 */
package massim.agent.implementation;

import massim.agent.framework.MessageContent;
import massim.agent.framework.Perception;
import massim.agent.framework.StringContent;


/**
 * @author pno
 *
 */
public class AgentB4 extends ExampleAsyncAgent {

	/**
	 * @param username
	 * @param password
	 */
	public AgentB4(String username, String password) {
		super(username, password);
		// TODO Auto-generated constructor stub
		//disableLogging();
	}

	@Override
	public synchronized String processRequestAction(Perception perception) {
		// an example of a communication action
		for (int i=0; i<100; i++) {
			broadcastMessage(new StringContent("B4 says hello " + i + " to all in step #" + getSimStep(), getSimStep()));
			//sendMessage(new StringContent(username + " says hello to agent b1!" + i, stepCounter), "b1");
			Thread.yield();
		}

		System.out.println("Under the agent B4 is a cell of type: " + perception.cells.get(Perception.pos(0, 1)));
		
		return "right";
	}


	@Override
	public synchronized void onMessageReceived(MessageContent msg) {
		// is invoked when the agent receives a new message from another agent
		
		System.out.println("B2 received a message: \"" + msg.toString() + "\" in step #" + getSimStep());

		if (msg.getTimestamp()==getSimStep()) {
			//*************************************************************************
			//TODO: process the message
			
			//*************************************************************************
		} else {
			// handle messages from the past, or from the "future"
			Thread.yield();
			if (msg.getTimestamp()<getSimStep()) {
				System.out.println("B4 throws away the message \"" + msg.toString() + "\" as too old");
				return;
			} else if (msg.getTimestamp()>getSimStep()) {
				System.out.println("B4 resends the message \"" + msg.toString() + "\" to future self");
				sendMessage(msg, username);
				return;
			}
		}
	}

	
}
