package massim.agent.implementation;

import massim.agent.framework.AbstractAsyncAgent;
import massim.agent.framework.MessageContent;
import massim.agent.framework.Perception;
import massim.agent.framework.StringContent;

import org.w3c.dom.Element;

public class ExampleAsyncAgent extends AbstractAsyncAgent {

	public ExampleAsyncAgent(String username, String password) {
		super(username, password);
	}
	// some notes on usage:
	public void processLogIn() {
		// called as soon as agent logged in successfully
		// TODO: insert code here
	}

	public void processSimulationEnd(Element perception, long currenttime) {
		super.processSimulationEnd(perception, currenttime);
		// react on simulation end
		// TODO: insert code here
	}

	public void processSimulationStart(Element perception, long currenttime) {
		super.processSimulationStart(perception, currenttime);
		// react on simulation start
		// TODO: insert code here
	}

	public synchronized String processRequestAction(Perception perception) {
		// an example of a communication action
		for (int i=0; i<100; i++) {
			broadcastMessage(new StringContent(username + " says hello " + i + " to all in step #" + getSimStep(), getSimStep()));
			//sendMessage(new StringContent(username + " says hello to agent b1!" + i, stepCounter), "b1");
			Thread.yield();
		}
		
		return "right";
	}
	
	public synchronized void onMessageReceived(MessageContent msg) {
		// is invoked when the agent receives a new message from another agent
		
		System.out.println(username + " received a message: \"" + msg.toString() + "\" in step #" + getSimStep());

		if (msg.getTimestamp()==getSimStep()) {
			//*************************************************************************
			//TODO: process the message
			
			//*************************************************************************
		} else {
			// handle messages from the past, or from the "future"
			Thread.yield();
			if (msg.getTimestamp()<getSimStep()) {
				System.out.println(username + " throws away the message \"" + msg.toString() + "\" as too old");
				return;
			} else if (msg.getTimestamp()>getSimStep()) {
				System.out.println(username + " resends the message \"" + msg.toString() + "\" to future self");
				sendMessage(msg, username);
				return;
			}
		}
	}
	
	// the main entry point into the agent deliberation loop
	@Override
	public void run() {
		// you can configure the agent's connection point
		run("localhost", 12300);
	}
}
