package massim.agent.jazzyk;

import java.util.HashMap;

/**
 * Register of MASSIm Agents running within the system. 
 * 
 * The class is implemented as a singleton.
 * 
 * @author pno
 *
 */
public class MASSimAgents {

	private static HashMap<String, JazzykAgent> agents = null;
	private static MASSimAgents instance = null;

	public MASSimAgents() {
		agents = new HashMap<String, JazzykAgent>();
	}
	
	public static MASSimAgents getInstance() {
		if (instance==null) {
			instance = new MASSimAgents(); 
		}
		
		return instance;
	}
	
	/**
	 * Registers a new agent into the registry. 
	 */
	public void register(String username, JazzykAgent agent) {
		agents.put(username, agent);
	}
	
	/**
	 * Returns a registered agent with the given username 
	 */
	public JazzykAgent getAgent(String username) {
		return agents.get(username);
	}
	
	/**
	 * Resets the registry and cleans it up.
	 */
	public void reset() {
		agents.clear();
	}
}
